let canvasSizeX = 1200;
let canvasSizeY = 800;
function preload() {
  table = loadTable(
    'https://gist.githubusercontent.com/vishusikka/6f7f957113b6c6bd69622ba6fd3486e0/raw/443697689e6b0f144e6b56eb7c8413c1bfeafda2/histogram4.csv',
    'csv',
    'header'
  );
}
this.countPerYear = {};

function setup() {
  createCanvas(canvasSizeX, canvasSizeY);
  readTable();
  printObject();
}

const scale = (num, in_min, in_max, out_min, out_max) => {
  return (
    ((num - in_min) * (out_max - out_min)) /
      (in_max - in_min) +
    out_min
  );
};

function readTable() {
  let row = table.getRow(1);
  //print it column by column
  for (let r = 0; r < table.getRowCount(); r++) {
    for (let c = 0; c < 2; c++) {
      this.countPerYear[
        table.getString(r, 0)
      ] = table.getNum(r, c);
    }
  }
}

this.values = [];

function printObject() {
  for (keyHorsepower in this.countPerYear) {
    values.push([
      keyHorsepower,
      countPerYear[keyHorsepower],
    ]);
    //print("Horsepower: " + keyHorsepower + " | Count: " + this.countPerYear[keyHorsepower] );
  }
}

let bar_spacing_px = 21;
let x_offset_px = 140;
let y_offset_px = 750;
let bar_width_px = 20;
let scaled_y = 0;
let scale_scaler = 0;
let scale_factor = 8;
let str;

function draw() {
  //draw grid
  stroke(240);
  //rect(i * 150 + 140, 145, 0.25, 305);
  //draw horiz lines
  line(1170, 100, 140, 100);
  line(1170, 150, 140, 150);
  line(1170, 200, 140, 200);
  line(1170, 250, 140, 250);
  line(1170, 300, 140, 300);
  line(1170, 350, 140, 350);
  line(1170, 400, 140, 400);
  line(1170, 450, 140, 450);
  line(1170, 500, 140, 500);
  line(1170, 550, 140, 550);
  line(1170, 600, 140, 600);
  line(1170, 650, 140, 650);
  line(1170, 700, 140, 700);

  fill(0, 161, 211);
  for (var i = 0; i < values.length; i++) {
    scaled_y = scale(
      values[i][1],
      0,
      100,
      0,
      canvasSizeY / scale_factor
    );
    fill(0, 161, 211);

    rect(
      i * bar_spacing_px + x_offset_px,
      y_offset_px - scaled_y,
      bar_width_px,
      scaled_y
    );

    str = values[i][0]; //.slice(2);
    fill('black');
    if (i == 13) {
      text(
        '9',
        i * bar_spacing_px + x_offset_px + -260,
        y_offset_px + 15
      );
      text(
        '13',
        i * bar_spacing_px + x_offset_px + -45,
        y_offset_px + 15
      );
      text(
        '15',
        i * bar_spacing_px + x_offset_px + 125,
        y_offset_px + 15
      );
      text(
        '17',
        i * bar_spacing_px + x_offset_px + 396,
        y_offset_px + 15
      );
      text(
        '26',
        i * bar_spacing_px + x_offset_px + 720,
        y_offset_px + 15
      );
      text(
        'Avg City mpg',
        i * bar_spacing_px + x_offset_px + 250,
        y_offset_px + 35
      );
      //text("Histogram", ((i * bar_spacing_px) + x_offset_px)+85, 135)
      text(
        'Histogram for avg city mpg by count across all makes and models 2009-2012',
        800,
        60
      );

      textAlign(LEFT);
      push();
      let angle2 = radians(-90);
      translate(-90, 280);
      rotate(angle2);
      text('Count', -130, 180);
      pop();
    }
    textAlign(LEFT);
    fill('#bbbbbb');
    textSize(10);
    text(
      values[i][1] + '/\n' + values[i][0],
      i * bar_spacing_px + x_offset_px,
      y_offset_px - scaled_y - 20
    );

    for (var x = 0; x <= 650; x = x + 50) {
      textAlign(RIGHT);
      fill('black');
      textSize(13);
      scale_scaler = scale(
        x,
        0,
        100,
        0,
        canvasSizeY / scale_factor
      );
      text(x, x_offset_px - 10, y_offset_px - scale_scaler);
    }
  }
}
